local mod = ...



-- Building Asset Processor
mod:registerAssetProcessor("models/Performer4.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Prefab -----------------------------------------------------------------------------------------------------------
mod:registerAssetId("models/Performer4.fbx/Prefab/Assemblage.Part.001", "PREFAB_ENTERTAINMENT_TRAINEDBEAR_ASSEMBLAGE")
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Part.001", "PREFAB_ENTERTAINMENT_TRAINEDBEAR1")
mod:registerAssetId("models/Performer4.fbx/Prefab/Room.Part.001", "PREFAB_ENTERTAINMENT_TRAINEDBEAR_ROOM")

mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Male.Front", "PREFAB_ENTERTAINMENT_TRAINEDBEAR_MALE_FRONT")
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Male.Hat", "PREFAB_ENTERTAINMENT_TRAINEDBEAR_MALE_HAT")

mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Female.Front", "PREFAB_ENTERTAINMENT_TRAINEDBEAR_FEMALE_FRONT")
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Female.Hat", "PREFAB_ENTERTAINMENT_TRAINEDBEAR_FEMALE_HAT")



-- Ground -------------------------------------------------------------------------------------
for i = 1, 8 do
    mod:registerPrefabComponent("models/Performer4.fbx/Prefab/Assemblage.Part.001/Attach_Minor.00" .. i, { DataType = "COMP_GROUNDED" })
end



-- Manual paths for buyer and seller ---------------------------------------------------------------------------------
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Part.001/PATH_A_1", "PATH_ENTERTAINMENT_TRAINEDBEAR1_1")
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Part.001/PATH_A_2", "PATH_ENTERTAINMENT_TRAINEDBEAR1_2")
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Part.001/PATH_B_1", "PATH_ENTERTAINMENT_TRAINEDBEAR2_1")
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Part.001/PATH_B_2", "PATH_ENTERTAINMENT_TRAINEDBEAR2_2")
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Part.001/PATH_B_3", "PATH_ENTERTAINMENT_TRAINEDBEAR2_3")
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Part.001/PATH_C_1", "PATH_ENTERTAINMENT_TRAINEDBEAR3_1")
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Part.001/PATH_C_2", "PATH_ENTERTAINMENT_TRAINEDBEAR3_2")
mod:registerAssetId("models/Performer4.fbx/Prefab/Trainer.Part.001/PATH_C_3", "PATH_ENTERTAINMENT_TRAINEDBEAR3_3")

mod:registerPrefabComponent("models/Performer4.fbx/Prefab/Trainer.Part.001", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = {
                "PATH_ENTERTAINMENT_TRAINEDBEAR1_1",
                "PATH_ENTERTAINMENT_TRAINEDBEAR1_2",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_TRAINEDBEAR2_1",
                "PATH_ENTERTAINMENT_TRAINEDBEAR2_2",
                "PATH_ENTERTAINMENT_TRAINEDBEAR2_3",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_TRAINEDBEAR3_1",
                "PATH_ENTERTAINMENT_TRAINEDBEAR3_2",
                "PATH_ENTERTAINMENT_TRAINEDBEAR3_3",
            },
        },
    }
})



-- Job: Bear Trainer -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "JOB",
	Id = "JOB_ENTERTAINMENT_TRAINEDBEAR",
	JobName = "JOB_ENTERTAINMENT_TRAINEDBEAR_NAME",
	JobDescription = "JOB_ENTERTAINMENT_TRAINEDBEAR_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 20.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        FemaleFrontList = {
            "PREFAB_ENTERTAINMENT_TRAINEDBEAR_FEMALE_FRONT",
        },
        FemaleHatList = {
            "PREFAB_ENTERTAINMENT_TRAINEDBEAR_FEMALE_HAT",
		},
        -- FemaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_TRAINEDBEAR_FEMALE_BELT",
        -- },
        MaleFrontList = {
            "PREFAB_ENTERTAINMENT_TRAINEDBEAR_MALE_FRONT",
        },
        MaleHatList = {
            "PREFAB_ENTERTAINMENT_TRAINEDBEAR_MALE_HAT",
		},
        -- MaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_TRAINEDBEAR_MALE_BELT",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "MARKET_TENDER",
	},
})

mod:overrideAsset({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_TRAINEDBEAR",
    },
})

mod:overrideAsset({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_TRAINEDBEAR",
    },
})

mod:overrideAsset({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_TRAINEDBEAR",
    },
})



-- Building Function: Trained Bear -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_ENTERTAINMENT_TRAINEDBEAR",
	Name = "BUILDING_FUNCTION_ENTERTAINMENT_TRAINEDBEAR_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = {
        Job = "JOB_ENTERTAINMENT_TRAINEDBEAR",
        Behavior = "BEHAVIOR_WORK",
    },
	TypeList = { "ENTERTAINMENT" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 5,
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	}
})



-- Building Part: Bear's Tent -------------------------------------------------------------------------------------

-- Trainer's Workplace
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_TRAINEDBEAR_SELLER",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_TRAINEDBEAR1",
	},
    AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_TRAINEDBEAR",
})

-- Room for spectators
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_TRAINEDBEAR_ROOM",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_TRAINEDBEAR_ROOM",
	},
})

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_TRAINEDBEAR_ASSEMBLAGE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_ENTERTAINMENT_TRAINEDBEAR_ASSEMBLAGE" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_ENTERTAINMENT_TRAINEDBEAR_SELLER", OptionalAttachNodeString = "Attach_Minor.001", },
			{ BuildingPart = "TENT_RW_XLARGE_PART", OptionalAttachNodeString = "Attach_Minor.002", }, -- from Medieval Faire mod
			{ BuildingPart = "HAYBALE3_PART", OptionalAttachNodeString = "Attach_Minor.003", }, -- from Fantasy Decorations mod
			{ BuildingPart = "GRAIN_PART", OptionalAttachNodeString = "Attach_Minor.004", }, -- from Fantasy Decorations mod
			{ BuildingPart = "BARREL_BERRIES_PART", OptionalAttachNodeString = "Attach_Minor.005", }, -- from Fantasy Decorations mod
			{ BuildingPart = "BARREL_FISH_PART", OptionalAttachNodeString = "Attach_Minor.006", }, -- from Fantasy Decorations mod
			{ BuildingPart = "SKULLS1_PART", OptionalAttachNodeString = "Attach_Minor.007", }, -- from Fantasy Decorations mod
			{ BuildingPart = "SKULLS2_PART", OptionalAttachNodeString = "Attach_Minor.008", }, -- from Fantasy Decorations mod
			{ BuildingPart = "BUILDING_PART_ENTERTAINMENT_TRAINEDBEAR_ROOM", OptionalAttachNodeString = "Attach_Minor.009", },
		},
	},
})

-- Final Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_ENTERTAINMENT_TRAINEDBEAR",
    Name = "BUILDING_PART_ENTERTAINMENT_TRAINEDBEAR_NAME",
    Description = "BUILDING_PART_ENTERTAINMENT_TRAINEDBEAR_DESC",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_ENTERTAINMENT_TRAINEDBEAR_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0.0,
            CameraPosition = { -0.25, 2.5, -24 },
            OrientationOffset = -20.0,
            CameraPitchOffset = 0.0
        },
    },
	BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 4.8, {0.0, 0.0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
			},
		},
	},
    Capacity = 4,
    AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 100 }
        },
        UpkeepCost = {
            { Resource = "GOLD_COINS", Quantity = 25 }
        },
        ResourceNeededList = {
            {
                { Resource = "WOOLEN_CLOTH", Quantity = 80 },
                { Resource = "TOOL", Quantity = 20 },
            },
        },
    },
})

